<script lang="ts">
  import { page } from '$app/stores';
  import { Gql } from '@db';
  import { getVariablesByPk } from '@queries/variables';
  import { EventRole } from '@auth/models';
  import { keycloak } from '@stores';
  import { onMount } from 'svelte';
  import {
    Breadcrumb,
    BreadcrumbItem,
    Button,
    Dropdown,
    DropdownItem,
    DropdownMenu,
    DropdownToggle,
  } from '@sveltestrap/sveltestrap';
  import { getNotificationsContext } from 'svelte-notifications';
  import requireRole from '@auth/PermissionRequired';
  import { JSONEditor } from 'svelte-jsoneditor';
  import type { CheckVariables, EventVariables, TeamVariables } from '@models/Variables';
  import { faSliders } from '@fortawesome/free-solid-svg-icons';
  import Fa from 'svelte-fa';

  requireRole(EventRole.EventAdmin);

  const { addNotification } = getNotificationsContext();
  let queryRole = $keycloak?.getFirstRole([EventRole.EventAdmin]);
  let vars: TeamVariables | EventVariables | CheckVariables;
  let editor;
  $: console.log(vars);
  $: content = { json: vars?.vars };

  type variableReturnTypes =
    | { variables_check_by_pk: CheckVariables }
    | { variables_team_by_pk: TeamVariables }
    | { variables_event_by_pk: EventVariables };

  onMount(() => {
    Gql.subscribeSimple<variableReturnTypes>(
      `subscription AdminVariableConfiguration ${getVariablesByPk($page.params.type, $page.params.id)}`,
      (data) => (vars = data[`variables_${$page.params.type}_by_pk`]),
      { queryRole },
    );
  });

  async function save() {
    const type = $page.params.type;

    try {
      let data = editor.get();
      if (data.json) data = data.json;
      else if (data.text) data = JSON.parse(data.text);
      else throw new Error('Data could not be retrieved from editor');

      // await Gql.query(
      await Gql.query(
        `mutation AdminUpsertVars($input: variables_${type}_insert_input!) {
          insert_variables_${type}_one(
            object: $input,
            on_conflict: {
                constraint: ${type}_pkey,
                update_columns: [vars]
            }
          ) {
            vars
          }
      }`,
        {
          queryRole,
          variables: {
            input: {
              ...vars, // get check_id/event_id/team_id from vars object
              vars: data, // but also update the actual var contents
            },
          },
        },
      );
    } catch (e) {
      addNotification({
        text: 'Failed to save variables',
        position: 'bottom-right',
        type: 'error',
        removeAfter: 2000,
      });
      throw e;
    }

    addNotification({
      text: 'Variables saved!',
      position: 'bottom-right',
      type: 'success',
      removeAfter: 2000,
    });
  }
</script>

<Breadcrumb>
  <BreadcrumbItem>Event Configuration</BreadcrumbItem>
  <BreadcrumbItem>
    <Dropdown setActiveFromChild>
      <DropdownToggle nav class="pe-2" caret>Variables</DropdownToggle>
      <DropdownMenu>
        <DropdownItem href="/admin/event-configuration/variables/check">
          <Fa icon={faSliders} /> Check Variables
        </DropdownItem>
        <DropdownItem href="/admin/event-configuration/variables/event">
          <Fa icon={faSliders} /> Event Variables
        </DropdownItem>
        <DropdownItem href="/admin/event-configuration/variables/team">
          <Fa icon={faSliders} /> Team Variables
        </DropdownItem>
      </DropdownMenu>
    </Dropdown>
  </BreadcrumbItem>
  <BreadcrumbItem>
    <a href="/admin/event-configuration/variables/{$page.params.type}">
      {$page.params.type}
    </a>
  </BreadcrumbItem>
  <BreadcrumbItem active>{vars?.[`${$page.params.type}`]?.name || $page.params.id}</BreadcrumbItem>
</Breadcrumb>

<Button class="float-end mb-3" color="success" on:click={save}>Save</Button>

<div class="m-3">
  {#if vars}
    <JSONEditor mode="text" bind:this={editor} {content} />
  {/if}
</div>
